﻿using Sugar.Enties;
using SqlSugar;
using System;
using System.Collections.Generic;
using Utils;
using System.Data;
using System.IO;

public class fdc_pm_meterrecordManager : DbContext<fdc_pm_meterrecord>
{
    private NLog.Logger logger;
    public fdc_pm_meterrecordManager()
    {
        logger = NLog.LogManager.GetCurrentClassLogger();
    }
  
  
    //当前类已经继承了 DbContext增、删、查、改的方法

    //这里面写的代码不会给覆盖,如果要重新生成请删除 fdc_pm_meterrecordManager.cs

    /// <summary>
    /// 根据业主手机号返回业主信息
    /// </summary>
    /// <param name="dto"></param>
    public OwnerDTO LoginOwner(string phone)
    {
        var sql = $"SELECT a.ownerid,a.ownername,c.hcode,c.hname,d.bcode,d.bname,a.tel FROM dbo.fdc_pm_owner a INNER JOIN dbo.fdc_pm_ownerhouse b ON a.ownerid=b.ownerid INNER JOIN fdc_pm_house c ON b.hcode=c.hcode INNER JOIN dbo.fdc_pm_build d ON c.bcode=d.bcode WHERE a.tel='{phone}'";
        var model = Db.Ado.SqlQuerySingle<OwnerDTO>(sql);
        return model;
    }
    /// <summary>
    /// 抄表单添加
    /// </summary>
    /// <param name="chaoBiaos"></param>
    /// <returns></returns>
    public string Fdc_pm_meterAdd(List<ChaobiaoDTO> chaoBiaos)
    {
        try
        {
            Db.BeginTran();
          
            var maxbillcodeManager = new maxbillcodeManager(Db);           
           

            foreach (var item in chaoBiaos)
            {
                //创建房产仪表表的对象
                fdc_pm_housemeter fdc_pm_housemeter = new fdc_pm_housemeter();
                //赋值房产编码
                fdc_pm_housemeter.hcode = item.hcode;
                //赋值仪表编码
                fdc_pm_housemeter.pk_meterid = item.pk_meterid;
                //获取房产仪表对象
                var housemeterModel = Db.Queryable<fdc_pm_housemeter>().Single(m=>m.pk_meterid==item.pk_meterid);
                //创建抄表单对象
                fdc_pm_meterrecord_b fdc_pm_meterrecord_b = new fdc_pm_meterrecord_b();
                //赋值
                fdc_pm_meterrecord_b.hcode = item.hcode;
                fdc_pm_meterrecord_b.pk_meterid = item.pk_meterid;
                //主表id
                DateTime dt = DateTime.Now;
                //获取编号
                var billcode = maxbillcodeManager.GetMaxBillCode("", PublicField.ID, false);
                //仪表名称
                fdc_pm_meterrecord_b.autoid = fdc_pm_meterrecord_b.autoid == "" ? billcode : fdc_pm_meterrecord_b.autoid;
                fdc_pm_meterrecord_b.metername = housemeterModel.metername;
                //水表名称               
                fdc_pm_meterrecord_b.billno = item.bcode + dt.ToString("yyyyMMdd") + item.Userid;
                //楼栋实例
                var buildModel = Db.Queryable<fdc_pm_build>().Single(m => m.bcode == item.bcode);
                if (!Db.Queryable<fdc_pm_meterrecord_b>().Any(m => m.billno == fdc_pm_meterrecord_b.billno))
                {
                    fdc_pm_meterrecord fdc_pm_meterrecord = new fdc_pm_meterrecord();
                    //抄表单主键
                    fdc_pm_meterrecord.billno = fdc_pm_meterrecord_b.billno;
                    //表的类型
                    fdc_pm_meterrecord.pk_metertypeid = housemeterModel.metertype;
                    fdc_pm_meterrecord.bcode = item.bcode;
                    fdc_pm_meterrecord.pcode = buildModel.pcode;
                    fdc_pm_meterrecord.metertime = DateTime.Now;
                    fdc_pm_meterrecord.employeid = item.Userid;
                    fdc_pm_meterrecord.flag = "0";
                    fdc_pm_meterrecord.voperatorid = item.Userid;
                    fdc_pm_meterrecord.doperatordate = DateTime.Now;
                    fdc_pm_meterrecord.billstatus = "3";

                    if (item.bdate.IsNullOrEmpty())
                    {
                        fdc_pm_meterrecord.bdate = DateTime.Now;
                    }
                    else
                    {
                        fdc_pm_meterrecord.bdate = item.bdate.ToDateTime();
                    }
                    fdc_pm_meterrecord.edate = DateTime.Now;
                    var secidModel = Db.Queryable<fdc_pm_userinmanagementsec>().Single(it => it.staffcode == item.Userid);

                    fdc_pm_meterrecord.pk_managementsecid = secidModel.pk_managementsecid;
                    Insert(fdc_pm_meterrecord);
                }


                var nlast = housemeterModel.amount;
                if (item.ncur.ToDecimal() < nlast)
                {
                    return "本期表小于上期表";
                }
                fdc_pm_meterrecord_b.flag = "0";
                fdc_pm_meterrecord_b.nlast = nlast;
                fdc_pm_meterrecord_b.ncur = item.ncur.ToDecimal();

                fdc_pm_meterrecord_b.ndosage = item.ncur.ToDecimal() - nlast;


                var success = new fdc_pm_meterrecord_bManager().Insert(fdc_pm_meterrecord_b);
            }
            Db.CommitTran();
            return "success";
        }
        catch (Exception ex)
        {
            Db.RollbackTran();
            logger.Error(ex);
            return "添加抄表单失败：" + ex.Message;
        }
    }

    /// <summary>
    /// 获取欠费对象
    /// </summary>
    /// <param name="phone"></param>
    public List<dynamic> Getfdc_pm_unfare(string phone)
    {
        var sql = $@"SELECT farerowid,e.weixinid,e.ownername,d.hname,f.billitemname,b.nneedpaymny,b.dbegindate,b.denddate,e.tel,e.ownerid FROM fdc_pm_fare a
            inner join fdc_pm_fare_b b on a.pk_farecode = b.pk_farecode
            inner join fdc_pm_house c on b.hcode = c.hcode
            inner join fdc_pm_ownerhouse d on c.hcode = d.hcode
            inner join fdc_pm_owner e on d.ownerid = e.ownerid
            inner join fdc_pm_billsitem f on b.billitemcode = f.billitemcode
            where b.nneedpaymny > nrevmny  AND e.tel = '{phone}'";
        var list = Db.SqlQueryable<dynamic>(sql).ToList();
        return list;
    }
    /// <summary>
    /// 获取缴费记录
    /// </summary>
    /// <param name="phone"></param>
    /// <returns></returns>
    public List<dynamic> Getfdc_pm_revfare(string phone)
    {
        var sql = $@"SELECT e.weixinid,e.ownername,c.hname,f.billitemname,b.nrevmny,b.dbdate,b.dedate
            FROM fdc_pm_revfare a
            inner join fdc_pm_revfare_b b on a.pk_revfarecode=b.pk_revfarecode
            inner join fdc_pm_house c on b.hcode=c.hcode
            inner join fdc_pm_ownerhouse d on c.hcode=d.hcode
            inner join fdc_pm_owner e on d.ownerid=e.ownerid
            inner join fdc_pm_billsitem f on b.billitemcode=f.billitemcode WHERE 1=1   AND e.tel = '{phone}'";
        var list = Db.SqlQueryable<dynamic>(sql).ToList();
        return list;
    }
    /// <summary>
    /// 获取报修记录
    /// </summary>
    /// <param name="phone"></param>
    /// <returns></returns>
    public List<dynamic>  GetRepaireList(string phone)
    {
        var sql = $@"SELECT e.username as voperatorname,f.username as vemployeename,d.deptname,a.*
              FROM fdc_pm_repairapply a 
                            INNER JOIN fdc_pm_house b on a.hcode=b.hcode 
                             INNER JOIN fdc_pm_owner c on a.ownerid=c.ownerid 
                            INNER JOIN  depts d on a.deptcode=d.deptcode 
                           LEFT JOIN users e on a.voperatorid=e.staffcode
                            LEFT JOIN users f on a.vemployeeid=f.staffcode
                           WHERE c.tel='{phone}'  and a.billtype<>'3' ";
        //logger.Info($"sql:{sql}");
        var list = Db.SqlQueryable<dynamic>(sql).OrderBy("dapplydate").ToList();
        return list;
    }

    /// <summary>
    /// 获取投诉记录
    /// </summary>
    /// <param name="phone"></param>
    /// <returns></returns>
    public List<dynamic> GetComplaintList(string phone)
    {
        var sql = $@"SELECT e.username as voperatorname,f.username as vemployeename,d.deptname,a.*
              FROM fdc_pm_repairapply a 
                            INNER JOIN fdc_pm_house b on a.hcode=b.hcode 
                             INNER JOIN fdc_pm_owner c on a.ownerid=c.ownerid 
                            INNER JOIN  depts d on a.deptcode=d.deptcode 
                           LEFT JOIN users e on a.voperatorid=e.staffcode
                            LEFT JOIN users f on a.vemployeeid=f.staffcode
                           WHERE c.tel='{phone}'  and a.billtype='3' order by a.dapplydate ";
        var list = Db.Ado.SqlQuery<dynamic>(sql);
        return list;
    }
    /// <summary>
    /// 获取房产信息
    /// </summary>
    /// <param name="phone"></param>
    /// <returns></returns>
    public List<dynamic> GetOwnerHouse(string phone)
    {
        var sql = $@" SELECT  a.ownerid,a.ownername,c.hname ,d.bname
                    FROM fdc_pm_owner a 
                    INNER JOIN fdc_pm_ownerhouse b on a.ownerid=b.ownerid and b.flag=1 
                    INNER JOIN  fdc_pm_house c on b.hcode=c.hcode 
                    inner join fdc_pm_build d on c.bcode=d.bcode 
                    inner join fdc_pm_project p on d.pcode=p.pcode 
                    where 1=1 and a.tel='{phone}'";
        var list = Db.SqlQueryable<dynamic>(sql).ToList();
        return list;
    }

    /// <summary>
    /// 添加报事单或者投诉单
    /// </summary>
    /// <param name="dto">需要插入的数据</param>
    /// <param name="type">0:报事单 1：投诉单</param>
    /// <returns></returns>
    public string Insertfdc_pm_repair( BaoshiDTO dto,int type)
    {
        Db.BeginTran();
        try
        {
            var maxbillcodeManager = new maxbillcodeManager(Db);
            string sid = maxbillcodeManager.GetMaxBillCode("", PublicField.RH, false);//获取最大单号
            string sql1 = string.Format("SELECT oh.hcode,o.ownerid FROM  dbo.fdc_pm_ownerhouse oh  INNER join dbo.fdc_pm_owner o ON o.ownerid=oh.ownerid WHERE o.tel='{0}'", dto.tel);
            logger.Info(string.Format("【Insertfdc_pm_repair】sql1:{0}", sql1));
            var model = Db.SqlQueryable<dynamic>(sql1).Single();
            if (model==null)
            {
                Db.RollbackTran();
                return "不存在的用户";
            }
            var hcode = model.hcode;
            var ownerid = model.ownerid;
            fdc_pm_repairapply fdc_pm_repairapplyinfo = new fdc_pm_repairapply();
            fdc_pm_repairapplyinfo.vtypecode = "10";//报事类型
            fdc_pm_repairapplyinfo.dapplydate = DateTime.Now;//日期
            fdc_pm_repairapplyinfo.dapplyer = "";
            fdc_pm_repairapplyinfo.dapprovedate = DateTime.Now;

            fdc_pm_repairapplyinfo.dclosedate = null;
            fdc_pm_repairapplyinfo.deptcode = "01";//处理部门编号
            fdc_pm_repairapplyinfo.dmakedate = DateTime.Now;
            fdc_pm_repairapplyinfo.drecievdate = null;

            fdc_pm_repairapplyinfo.drequiredate = dto.txtdrequiredate;
            fdc_pm_repairapplyinfo.hcode = hcode;
            fdc_pm_repairapplyinfo.ownerid = ownerid;
            fdc_pm_repairapplyinfo.pk_corp = "";

            fdc_pm_repairapplyinfo.pk_managementsecid = "";
            fdc_pm_repairapplyinfo.vapproveid = "";
            fdc_pm_repairapplyinfo.vapprovenote = "";
            fdc_pm_repairapplyinfo.vbillno = sid;

            fdc_pm_repairapplyinfo.vbillstatus = "1";
            fdc_pm_repairapplyinfo.vcontent = dto.content;//报事内容
            fdc_pm_repairapplyinfo.vemployeeid = "0002";//处理人编号
            fdc_pm_repairapplyinfo.voperatorid = "0001";//处理人编号

            fdc_pm_repairapplyinfo.vmemo = "暂无";//备注
            fdc_pm_repairapplyinfo.vplace = dto.place;
            fdc_pm_repairapplyinfo.vrepairapplycode = sid;
            fdc_pm_repairapplyinfo.vtel = dto.tel;

            fdc_pm_repairapplyinfo.bclose = "0";
            fdc_pm_repairapplyinfo.fsatisfied = "";
            fdc_pm_repairapplyinfo.dbilldate = DateTime.Now;
            fdc_pm_repairapplyinfo.billtype =type==1?"3": "1";//报事类型

            var entity = Db.Insertable(fdc_pm_repairapplyinfo).ExecuteReturnEntity();
            
           foreach(var item in dto.fileList)
            {
                var name = Guid.NewGuid().ToString();
                var filename= Guid.NewGuid().ToString() + Path.GetExtension(item.Name);
                var uploadSuccess = UploadFileHelper.Base64StringToFile(item.Content, filename);
                if(!uploadSuccess)
                {
                    Db.RollbackTran();
                    return "上传失败";
                }
               string sql = $"insert into Fdc_pm_file values ('{entity.vrepairapplycode}','{filename}','{name}')";
               var row=Db.Ado.ExecuteCommand(sql);
                if (row <= 0)
                {
                    Db.RollbackTran();
                    return "保存上传文件失败";
                }
            }
           
            Db.CommitTran();
            return "success";
        }
        catch(Exception ex)
        {
            Db.RollbackTran();
            //logger.Error(ex);
            throw;
        }
    }


    /// <summary>
    /// 插入缴费数据
    /// </summary>
    /// <param name="farwarid"></param>
    /// <param name="money"></param>
    /// <param name="ownername"></param>
    /// <param name="hname"></param>
    /// <returns></returns>
    public string InsertPay(string farwarid, string money, string ownername, string hname)
    {
        SetValue(farwarid, money);
        Db.BeginTran();
        try
        {
            var sql = " SELECT  ISNULL(a.nrevmny,0) nrevmny,b.rate,a1.voperatorid,f.psgn,b.bsgn,a.memo,a1.cmemo,a1.vownername,'' as pk_billno,a.dneeddate,'N' as prerevflag,a.farerowid, a.pk_farecode, a.hcode,d.hname,d.define7,d.define8, a.ownerid, c.ownername,a.pk_meterid, a.vactymbegin, a.vactymend, a.dbegindate, a.denddate,a.dbegindate as dbdate,a.denddate as dedate, a.billitemcode,b.billitemname, a.memo,ISNULL(a.nneedpaymny,0) incomemny, (ISNULL(a.nneedpaymny,0)-ISNULL(a.nrevmny,0)) as  nneedpaymny, a.nremainmny, a.ndebitlatemny, a.ndebitmny, a.nlatefeemny, a.namount, a.ncurreading, a.nlastreading, a.nprice ,a.rentcontractid,a.pk_corp,a.deptcode,a.pk_managementsecid,a.isback,a.edate ,a.narea  " +
                                " FROM fdc_pm_fare_b a " +
                                " INNER JOIN fdc_pm_billsitem b on  a.billitemcode=b.billitemcode" +
                                " LEFT JOIN fdc_pm_owner c on a.ownerid=c.ownerid " +
                                " INNER JOIN fdc_pm_house d on a.hcode=d.hcode " +
                                " INNER JOIN fdc_pm_build e on d.bcode=e.bcode " +
                                " INNER JOIN fdc_pm_project f on e.pcode=f.pcode " +
                                " LEFT JOIN   (select pk_farecode,voperatorid,cmemo,vownername from fdc_pm_fare union all select pk_calfarecode,voperatorid,'',''  from fdc_pm_calfare union all select contractid,voperatorid, '','' from dbo.fdc_pm_rentcontract ) a1 on a.pk_farecode=a1.pk_farecode " +
                                " WHERE convert(varchar(20),a.farerowid) in('" + farwarid.ToString().Replace(",", "','") + "')   order by a.hcode, nneedpaymny ";

            var model = Db.Ado.SqlQuerySingle<dynamic>(sql);

            //收款主表
            fdc_pm_revfare fdc_pm_revfareinfo = new fdc_pm_revfare();
            //判断时候是预收款
            fdc_pm_revfareinfo.prerevflag = "N";
            //收款单编码
            fdc_pm_revfareinfo.pk_revfarecode = "WXPay10001";
            //票据编码
            fdc_pm_revfareinfo.pk_billno = "";
            //收款日期
            fdc_pm_revfareinfo.dbilldate = DateTime.Now.Date;
            //操作日期
            fdc_pm_revfareinfo.doperatordate = DateTime.Now.Date;
            //房产编码
            fdc_pm_revfareinfo.hcode = model.hcode.ToString();

            //备注
            fdc_pm_revfareinfo.memo = "";
            //业主编码
            fdc_pm_revfareinfo.ownerid = model.ownerid.ToString();

            //业主名称
            fdc_pm_revfareinfo.vownername = model.ownername.ToString();
            if (ownername != model.ownername.ToString())
            {
                Db.RollbackTran();
                return "业主姓名不对";
            }
            if (hname != model.hanme.ToString())
            {
                Db.RollbackTran();
                return "房产名称不对";
            }
            fdc_pm_revfareinfo.pk_actym = "";
            //收款单编码
            //fdc_pm_revfareinfo.pk_revfarecode = "WXPay10001";
            //实收金额
            fdc_pm_revfareinfo.revnmny = money.ToDecimal();
            //收款人id
            fdc_pm_revfareinfo.voperatorid = "1121";
            //实收金额   （重复）
            fdc_pm_revfareinfo.revnmny = money.ToDecimal();
            //收费类型
            fdc_pm_revfareinfo.paytype = "1001";
            fdc_pm_revfareinfo.billtype = "S";//普通收款单
            fdc_pm_revfareinfo.billstatus = PublicField.APP_ORIGINAL;
            //是否开票
            //fdc_pm_revfareinfo.Vouchflag = "flag";
            //缴费卡id
            fdc_pm_revfareinfo.vownerid = "";


            sql = $"SELECT a.csscode, a.cssname, a.jfcode, a.jfname, a.dfcode, a.dfname, a.cmemo,a.rate,a.ssgn  FROM settletype a  WHERE csscode='{fdc_pm_revfareinfo.paytype}' ";
            var model1 = Db.Ado.SqlQuerySingle<dynamic>(sql);

            //获取结算方式单据标示
            string ssgn = model1.ssgn.ToString();
            var psgn = model.psgn.ToString() + ssgn.Trim();



            /////////////////////////////////////////////////////////////////////////////////////
            decimal summny = 0;
            foreach (fdc_pm_revfare_b fdc_pm_revfare_bitem in fdc_pm_revfare_blist)
            {

                summny += Convert.ToDecimal(fdc_pm_revfare_bitem.nrevmny);

            }

            sql = " SELECT  ISNULL(a.nrevmny,0) nrevmny,b.rate,a1.voperatorid,f.psgn,b.bsgn,a.memo,a1.cmemo,a1.vownername,'' as pk_billno,a.dneeddate,'N' as prerevflag,a.farerowid, a.pk_farecode, a.hcode,d.hname,d.define7,d.define8, a.ownerid, c.ownername,a.pk_meterid, a.vactymbegin, a.vactymend, a.dbegindate, a.denddate,a.dbegindate as dbdate,a.denddate as dedate, a.billitemcode,b.billitemname, a.memo,ISNULL(a.nneedpaymny,0) incomemny, (ISNULL(a.nneedpaymny,0)-ISNULL(a.nrevmny,0)) as  nneedpaymny, a.nremainmny, a.ndebitlatemny, a.ndebitmny, a.nlatefeemny, a.namount, a.ncurreading, a.nlastreading, a.nprice ,a.rentcontractid,a.pk_corp,a.deptcode,a.pk_managementsecid,a.isback,a.edate ,a.narea  " +
                                 " FROM fdc_pm_fare_b a " +
                                 " INNER JOIN fdc_pm_billsitem b on  a.billitemcode=b.billitemcode" +
                                 " LEFT JOIN fdc_pm_owner c on a.ownerid=c.ownerid " +
                                 " INNER JOIN fdc_pm_house d on a.hcode=d.hcode " +
                                 " INNER JOIN fdc_pm_build e on d.bcode=e.bcode " +
                                 " INNER JOIN fdc_pm_project f on e.pcode=f.pcode " +
                                 " LEFT JOIN   (select pk_farecode,voperatorid,cmemo,vownername from fdc_pm_fare union all select pk_calfarecode,voperatorid,'',''  from fdc_pm_calfare union all select contractid,voperatorid, '','' from dbo.fdc_pm_rentcontract ) a1 on a.pk_farecode=a1.pk_farecode " +
                                 " WHERE convert(varchar(20),a.farerowid) in('" + farwarid.Replace(",", "','") + "')   order by a.hcode, nneedpaymny ";
            //根据id查询账单数据
            var model3 = Db.Ado.SqlQuerySingle<dynamic>(sql);
            if (model3 != null)
            {

                fdc_pm_revfareinfo.vcreaterid = model3.voperatorid.ToString();

            }
            string id = "";
            string maxbillcode = "";
            string sgn = "S";
            sgn = psgn == "" ? "S" : psgn;

            var service = new maxbillcodeManager(Db);

            maxbillcode = service.GetMaxBillCode("", sgn, false);
            //收款单编码
            fdc_pm_revfareinfo.pk_revfarecode = maxbillcode;

            if (Db.Queryable<fdc_pm_revfare>().Any(m => m.pk_revfarecode == maxbillcode))    //若存在主表数据，则删除
            {
                Db.Deleteable<fdc_pm_revfare>().In(maxbillcode).ExecuteCommand();
            }

            //再重新插入缴费主表
            Db.Insertable(fdc_pm_revfareinfo).ExecuteCommand();
            //先删除缴费明细数据
            Db.Deleteable<fdc_pm_revfare_b>().Where(it => it.pk_revfarecode == maxbillcode).ExecuteCommand();
            foreach (fdc_pm_revfare_b item in fdc_pm_revfare_blist)
            {
                item.revfarerowid = service.GetMaxBillCode("", PublicField.ID, false);
            }
            //重新插入明细数据
            Db.Insertable(fdc_pm_revfare_blist).ExecuteCommand();
            Db.CommitTran();
            return "success";

        }
        catch(Exception ex)
        {
            Db.RollbackTran();
            logger.Error(ex);
            throw;
        }

    }

    /// <summary>
    /// 收费详细列表
    /// </summary>
    private List<fdc_pm_revfare_b> fdc_pm_revfare_blist = new List<fdc_pm_revfare_b>();
    private void SetValue(String id, String money)
    {
        String flag = "new";
        fdc_pm_revfare_b fdc_pm_revfare_binfo;

        String sql = " SELECT  ISNULL(a.nrevmny,0) nrevmny,b.rate,a1.voperatorid,f.psgn,b.bsgn,a.memo,a1.cmemo,a1.vownername,'' as pk_billno,a.dneeddate,'N' as prerevflag,a.farerowid, a.pk_farecode, a.hcode,d.hname,d.define7,d.define8, a.ownerid, c.ownername,a.pk_meterid, a.vactymbegin, a.vactymend, a.dbegindate, a.denddate,a.dbegindate as dbdate,a.denddate as dedate, a.billitemcode,b.billitemname, a.memo,ISNULL(a.nneedpaymny,0) incomemny, (ISNULL(a.nneedpaymny,0)-ISNULL(a.nrevmny,0)) as  nneedpaymny, a.nremainmny, a.ndebitlatemny, a.ndebitmny, a.nlatefeemny, a.namount, a.ncurreading, a.nlastreading, a.nprice ,a.rentcontractid,a.pk_corp,a.deptcode,a.pk_managementsecid,a.isback,a.edate ,a.narea  " +
                            " FROM fdc_pm_fare_b a " +
                            " INNER JOIN fdc_pm_billsitem b on  a.billitemcode=b.billitemcode" +
                            " LEFT JOIN fdc_pm_owner c on a.ownerid=c.ownerid " +
                            " INNER JOIN fdc_pm_house d on a.hcode=d.hcode " +
                            " INNER JOIN fdc_pm_build e on d.bcode=e.bcode " +
                            " INNER JOIN fdc_pm_project f on e.pcode=f.pcode " +
                            " LEFT JOIN   (select pk_farecode,voperatorid,cmemo,vownername from fdc_pm_fare union all select pk_calfarecode,voperatorid,'',''  from fdc_pm_calfare union all select contractid,voperatorid, '','' from dbo.fdc_pm_rentcontract ) a1 on a.pk_farecode=a1.pk_farecode " +
                            " WHERE convert(varchar(20),a.farerowid) in('" + id.ToString().Replace(",", "','") + "')   order by a.hcode, nneedpaymny ";

        DataTable dsi = new DataTable();
        if (flag == "new")
        {
            dsi = Db.Ado.GetDataTable(sql);

        }
        for (int i = 0; i < dsi.Rows.Count; i++)
        {

            fdc_pm_revfare_binfo = new fdc_pm_revfare_b();
            fdc_pm_revfare_binfo.billitemcode = dsi.Rows[i]["billitemcode"].ToString();
            //fdc_pm_revfare_binfo.billitemname = dsi.Rows[i]["billitemname"].ToString();
            fdc_pm_revfare_binfo.hcode = dsi.Rows[i]["hcode"].ToString();
            //fdc_pm_revfare_binfo.hname = dsi.Rows[i]["hname"].ToString();
            //fdc_pm_revfare_binfo.rate = dsi.Rows[i]["rate"].ToString();




            //如果收款则如果是修改则
            if (flag == "new")
            {
                fdc_pm_revfare_binfo.nneedmny = dsi.Rows[i]["nneedpaymny"].ToDecimal();
                fdc_pm_revfare_binfo.nrevmny = money.ToDecimal();
                if (dsi.Rows[i]["rate"].ToString() != "")
                {
                    var rate = dsi.Rows[i]["rate"].ToString();
                    fdc_pm_revfare_binfo.incomemny = Math.Round(Convert.ToDecimal(fdc_pm_revfare_binfo.nrevmny.ToString()) * Convert.ToDecimal("100") / (Convert.ToDecimal("100") + Convert.ToDecimal(rate)), 2, MidpointRounding.AwayFromZero).ToString();
                    fdc_pm_revfare_binfo.ratemny = Math.Round(Convert.ToDecimal(fdc_pm_revfare_binfo.nrevmny.ToString()) * Convert.ToDecimal(rate) / (Convert.ToDecimal("100") + Convert.ToDecimal(rate)), 2, MidpointRounding.AwayFromZero).ToString();

                }

                fdc_pm_revfare_binfo.prerevflag = dsi.Rows[i]["Prerevflag"].ToString();
                fdc_pm_revfare_binfo.nprice = dsi.Rows[i]["Nprice"].ToString();
                fdc_pm_revfare_binfo.memo = dsi.Rows[i]["memo"].ToString();

            }
            else
            {

                fdc_pm_revfare_binfo.nneedmny = dsi.Rows[i]["Needmny"].ToDecimal();
                fdc_pm_revfare_binfo.nrevmny = dsi.Rows[i]["Nrevmny"].ToDecimal();
                if (dsi.Rows[i]["rate"].ToString() != "")
                {
                    var rate = dsi.Rows[i]["rate"].ToString();
                    fdc_pm_revfare_binfo.incomemny = Math.Round(Convert.ToDecimal(fdc_pm_revfare_binfo.nrevmny.ToString()) * Convert.ToDecimal("100") / (Convert.ToDecimal("100") + Convert.ToDecimal(rate)), 2, MidpointRounding.AwayFromZero).ToString();
                    fdc_pm_revfare_binfo.ratemny = Math.Round(Convert.ToDecimal(fdc_pm_revfare_binfo.nrevmny.ToString()) * Convert.ToDecimal(rate) / (Convert.ToDecimal("100") + Convert.ToDecimal(rate)), 2, MidpointRounding.AwayFromZero).ToString();

                }
                fdc_pm_revfare_binfo.prerevflag = dsi.Rows[i]["Prerevflag_b"].ToString();

                fdc_pm_revfare_binfo.revfarerowid = dsi.Rows[i]["Revfarerowid"].ToString();
                fdc_pm_revfare_binfo.pk_revfarecode = dsi.Rows[i]["Pk_revfarecode"].ToString();
            }


            fdc_pm_revfare_binfo.dbdate = dsi.Rows[i]["edate"].ToString() == "" ? Convert.ToDateTime(dsi.Rows[i]["dbdate"].ToString()) : Convert.ToDateTime(dsi.Rows[i]["edate"].ToString()).AddDays(1);
            fdc_pm_revfare_binfo.dedate = Convert.ToDateTime(dsi.Rows[i]["dedate"].ToString());
            //fdc_pm_revfare_binfo.dneeddate = dsi.Rows[i]["edate"].ToString() == "" ? Convert.ToDateTime(dsi.Rows[i]["dneeddate"].ToString()).ToShortDateString() : Convert.ToDateTime(dsi.Rows[i]["edate"].ToString()).AddDays(1).ToShortDateString();

            // fdc_pm_revfare_binfo.Pk_revfarecode = this.txtpk_revfarecode.Text.ToString();

            fdc_pm_revfare_binfo.billtype = "S";
            fdc_pm_revfare_binfo.narea = dsi.Rows[i]["narea"].ToString();
            fdc_pm_revfare_binfo.nrevlatemny = 0;
            fdc_pm_revfare_binfo.nlatemny = 0;
            fdc_pm_revfare_binfo.farerowid = dsi.Rows[i]["Farerowid"].ToString();
            fdc_pm_revfare_binfo.issettle = "0";
            fdc_pm_revfare_binfo.isvouch = "0";
            fdc_pm_revfare_binfo.voucherid = "";
            fdc_pm_revfare_blist.Add(fdc_pm_revfare_binfo);
        }


        //hddfdc_pm_revfare_b = JSON.Serialize(fdc_pm_revfare_blist);//序列号
    }
    /// <summary>
    /// 获取报修详情
    /// </summary>
    /// <param name="code"></param>
    /// <returns></returns>
    public dynamic GetRepairDetail(string code)
    {
        var sql = $@"SELECT e.username as voperatorname,f.username as vemployeename,d.deptname,a.*
              FROM fdc_pm_repairapply a 
                            INNER JOIN fdc_pm_house b on a.hcode=b.hcode 
                             INNER JOIN fdc_pm_owner c on a.ownerid=c.ownerid 
                            INNER JOIN  depts d on a.deptcode=d.deptcode 
                           LEFT JOIN users e on a.voperatorid=e.staffcode
                            LEFT JOIN users f on a.vemployeeid=f.staffcode
                           WHERE a.vrepairapplycode='{code}' ";
        //logger.Info($"sql:{sql}");
        var model = Db.SqlQueryable<dynamic>(sql).First();
        return model;
    }
}